<a href="https://craftcms.com/" rel="noopener" target="_blank"><img width="247" height="60" src="https://craftcms.com/craftcms.svg" alt="Craft CMS"></a>

<br>

## About Craft CMS

Craft is a flexible, user-friendly CMS for creating custom digital experiences on the web and beyond.

It features:

- An intuitive, user-friendly control panel for content creation and administrative tasks.
- A clean-slate approach to content modeling that doesn’t make any assumptions about the content you need to manage.
- An auto-generated [GraphQL API](https://docs.craftcms.com/v3/graphql.html) that can be consumed for building headless applications.
- A fast and flexible [templating system](https://docs.craftcms.com/v3/dev/) based on Twig for building traditional websites.
- A powerful [ecommerce platform](https://craftcms.com/commerce) for building bespoke ecommerce experiences.
- A built-in Plugin Store with hundreds of free and commercial [plugins](https://plugins.craftcms.com/).
- A robust framework for [module and plugin development](https://docs.craftcms.com/v3/extend/).
- An active, vibrant [community](https://craftcms.com/community).

You can learn more about it at [craftcms.com](https://craftcms.com), and documentation is available at [docs.craftcms.com](https://docs.craftcms.com/v3/).

## Tech Specs

Craft is a self-hosted PHP 7 application. It can connect to MySQL and PostgreSQL for content storage. See [Server Requirements](https://docs.craftcms.com/v3/requirements.html) for more details.

## Popular Resources

- **[Tutorial](https://docs.craftcms.com/tutorial/)** – Get set up and learn the basics.
- **[Documentation](http://docs.craftcms.com/v3/)** – Read the official docs.
- **[Knowledge Base](https://craftcms.com/knowledge-base)** – Find answers to common problems.
- **[#craftcms](https://twitter.com/hashtag/craftcms)** – See the latest tweets about Craft.
- **[Discord](https://craftcms.com/discord)** – Meet the community.
- **[Stack Exchange](http://craftcms.stackexchange.com/)** – Get help and help others.
- **[CraftQuest](https://craftquest.io/)** – Watch unlimited video lessons and courses.
- **[Craft Link List](http://craftlinklist.com/)** – Stay in-the-know.
- **[nystudio107 Blog](https://nystudio107.com/blog)** – Learn Craft and modern web development.

---

<p>
<a href="https://travis-ci.com/craftcms/cms"><img src="https://img.shields.io/travis/com/craftcms/cms/develop.svg?label=build" alt="Build Status"></a>
<a href="https://packagist.org/packages/craftcms/cms"><img src="https://img.shields.io/packagist/dt/craftcms/cms.svg?label=downloads" alt="Total Packagist Downloads"></a>
<a href="https://github.com/craftcms/cms/releases"><img src="https://img.shields.io/github/tag/craftcms/cms.svg?label=stable" alt="Latest Stable Version"></a>
</p>
